package com.zskk.dicom.monitor.uploader;

import com.zskk.dicom.monitor.config.Configs;
import com.zskk.dicom.monitor.report.ErrReporter;
import com.zskk.dicom.monitor.utils.ExceptionUtil;

import java.io.File;
import java.util.concurrent.TimeUnit;
/**
 *
 * 功能描述: 重试文件上传
 *
 * @param:
 * @return: 
 * @auther: zzp
 * @date:
 */
public class RetryUploadRunner implements Runnable{
    @Override
    public void run() {
        while(true) {
            boolean flag = upload();
            Configs.sysLog.info("--RetryFileQueue-- System upload flag:" + flag + "\nFileUploader.failFileQueue.size：" + UploadsQueue.failFileQueue.size());
            try {
                if(flag) {
                    TimeUnit.MILLISECONDS.sleep(10);
                } else {
                    TimeUnit.SECONDS.sleep(1);
                }
            } catch (InterruptedException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
    }

    public synchronized static boolean upload() {
        boolean flag = false;
        try {
            // 从队列中移除已完成任务
            if(UploadsQueue.failFileQueue.size() > 0) {
                System.out.println("重试文件"+UploadsQueue.failFileQueue.size()+"个-----------------------");
                File file = UploadsQueue.failFileQueue.remove(0);
                FileUploader_two.upload(file);

                flag = true;
            }
        } catch (Throwable e) {
            ErrReporter.report(ExceptionUtil.getExceptionTxt(e));
            e.printStackTrace();
        }
        return flag;
    }
}
