package com.zskk.dicom.oss;


import cn.ucloud.ufile.UfileClient;
import cn.ucloud.ufile.api.object.ObjectConfig;
import cn.ucloud.ufile.auth.ObjectAuthorization;
import cn.ucloud.ufile.auth.UfileObjectLocalAuthorization;
import cn.ucloud.ufile.bean.base.BaseResponseBean;
import cn.ucloud.ufile.util.MimeTypeUtil;
import com.aliyun.oss.common.utils.IOUtils;
import com.zskk.dicom.monitor.config.Configs;
import org.apache.commons.codec.digest.DigestUtils;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.Date;

public class LCOSSFileAndCallbackHleper {
	private static final String PUBLIC_KEY = "TOKEN_29e194bf-beff-4155-a205-daf0feddcf65";
	private static final String PRIVATE_KEY = "61e2695b-42a0-4190-a460-a2031325b9d2";
	private static final ObjectAuthorization OBJECT_AUTHORIZER = new UfileObjectLocalAuthorization(PUBLIC_KEY, PRIVATE_KEY);
	private static final String REGION = "cn-inspur2";
	private static final String PORXY_SUFFIX = "ufileos.com";
//	private static final String CUSTOM_HOST = "www.cn-bj.ufileos.com";
//	private static final String CUSTOM_HOST = "api.spark.ucloud.cn";
//private static final String CUSTOM_HOST = "zskkdcm.infile.inspurcloud.cn";
	private static final String CUSTOM_HOST = Configs.lcCustomHost;

	public static boolean upload(File file) {
		ObjectConfig config = new ObjectConfig(REGION, PORXY_SUFFIX);
		config.setCustomHost(CUSTOM_HOST);

		FileInputStream fis = null;
		String md5 = null;
		String fileName = null;
		long length = -1;
		Exception error = null;
		try {
			fis = new FileInputStream(file);
			md5 = DigestUtils.md5Hex(IOUtils.readStreamAsByteArray(fis));
			fileName = Configs.hospitalId + "/" + md5;
//			fileName = Configs.hospitalId + File.separator + md5;
//			fileName =  md5;
			length = file.length();
			fis.close();
			Configs.sysLog.info("md5" + md5);
			Configs.sysLog.info("当前时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));

			BaseResponseBean response = UfileClient.object(OBJECT_AUTHORIZER, config)
                    .putObject(file, MimeTypeUtil.getMimeType(file))
                    .nameAs(fileName)
                    .toBucket("zskkdcm")
                    /**
                     * 是否上传校验MD5, Default = true
                     */
//                      .withVerifyMd5(false)
                    /**
                     * 指定progress callback的间隔, Default = 每秒回调
                     */
                    //  .withProgressConfig(ProgressConfig.callbackWithPercent(10))
                    /**
                     * 配置进度监听
                     */
//                    .setOnProgressListener(new OnProgressListener() {
//                        @Override
//                        public void onProgress(long bytesWritten, long contentLength) {
//							Configs.sysLog.debug("上传文件进度" + bytesWritten + ":" + contentLength);
//                        }
//                    })
                    .execute();
			Configs.sysLog.info("UploadHitSample" + String.format("[res] = %s", (response == null ? "null" : response.toString())) + "{\"RetCode\":0}".equals(response.toString()));
			if(response == null || (!response.toString().contains("ETag") && !"{\"RetCode\":0}".equals(response.toString()))) {
				Configs.sysLog.info("ETag is null");
				return false;
			}
			Configs.sysLog.info("发起浪潮oss解析请求" + Configs.lcossCallbackUrl);
			URL url = new URL(Configs.lcossCallbackUrl);
			HttpURLConnection connection = (HttpURLConnection) url.openConnection();
			connection.setRequestMethod("POST");
			connection.setDoOutput(true);
			connection.setDoInput(true);
			connection.setUseCaches(false);
			connection.connect();
			String body = "path=" + file.getAbsolutePath() +  "&md5="+md5+"&url="+fileName+ "&hospitalId=" + Configs.hospitalId + "&size=" + length +"&response="+ response.toString();
			BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(connection.getOutputStream(), "UTF-8"));
			writer.write(body);
			writer.close();

			int responseCode = connection.getResponseCode();
			if(responseCode == HttpURLConnection.HTTP_OK){
				StringBuilder strBuf = new StringBuilder();
				BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
				try {
					String line = null;
					while ((line = reader.readLine()) != null) {
						strBuf.append(line).append("\n");
					}
				} finally {
					reader.close();
				}
				String rs = strBuf.toString();
				Configs.sysLog.info("rs" + rs);
				if(rs.contains("true")) {
					return true;
				}
			}
		} catch(Exception e) {
			error = e;
		}
//		catch (UfileClientException e) {
//			Configs.sysLog.debug("UfileClientException" + e.getMessage());
//			e.printStackTrace();
//			return false;
//		} catch (UfileServerException e) {
//			Configs.sysLog.debug("UfileServerException" + e.getMessage());
//			e.printStackTrace();
//			return false;
//		} catch (IOException e) {
////			ErrReporter.report(ExceptionUtil.getExceptionTxt(e));
//			Configs.sysLog.info("IOException" + e.getMessage());
//			e.printStackTrace();
//			return false;
//		} catch (Exception e) {
////			ErrReporter.report(ExceptionUtil.getExceptionTxt(e));
//			Configs.sysLog.info("Exception" + e.getMessage());
//			e.printStackTrace();
//			return false;
//		}
		if(error != null) {
			Configs.sysLog.error("Exception" + error.getMessage());
			error.printStackTrace();
			return false;
		}
		return true;
	}
}
